diff --git a/engines/pegasus/neighborhood/tsa/fulltsa.cpp b/engines/pegasus/neighborhood/tsa/fulltsa.cpp
index 75f652a..31f84e7 100644
--- a/engines/pegasus/neighborhood/tsa/fulltsa.cpp
+++ b/engines/pegasus/neighborhood/tsa/fulltsa.cpp
@@ -23,12 +23,16 @@
  *
  */
 
+#include "common/file.h"
+
+#include "pegasus/compass.h"
 #include "pegasus/cursor.h"
 #include "pegasus/energymonitor.h"
 #include "pegasus/gamestate.h"
 #include "pegasus/pegasus.h"
 #include "pegasus/ai/ai_area.h"
 #include "pegasus/items/biochips/aichip.h"
+#include "pegasus/items/biochips/arthurchip.h"
 #include "pegasus/items/biochips/opticalchip.h"
 #include "pegasus/neighborhood/caldoria/caldoria.h"
 #include "pegasus/neighborhood/norad/constants.h"
@@ -480,7 +484,7 @@ const CoordType kRedirectionFDRolloverTop = kNavAreaTop + 160;
 const CoordType kRedirectionCCDoorLeft = kNavAreaLeft + 174;
 const CoordType kRedirectionCCDoorTop = kNavAreaTop + 36;
 
-const CoordType kRedirectionRRDoorLeft = kNavAreaLeft + 418;
+const CoordType kRedirectionRRDoorLeft = kNavAreaLeft + 428;
 const CoordType kRedirectionRRDoorTop = kNavAreaTop + 32;
 
 const CoordType kRedirectionFDDoorLeft = kNavAreaLeft + 298;
@@ -521,6 +525,10 @@ static const bool kPegasusResolved = true;
 static const bool kPegasusCantExit = false;
 static const bool kPegasusCanExit = true;
 
+static const ExtraID kEasterEggJimenez = 1000;
+static const ExtraID kEasterEggCastillo = 1001;
+static const ExtraID kEasterEggSinclair = 1002;
+
 // Monitor modes
 enum {
 	kMonitorNeutral = 0,
@@ -644,7 +652,8 @@ void RipTimer::timeChanged(const TimeValue newTime) {
 }
 
 FullTSA::FullTSA(InputHandler *nextHandler, PegasusEngine *owner) : Neighborhood(nextHandler, owner, "Full TSA", kFullTSAID),
-		_ripTimer(kNoDisplayElement), _sprite1(kNoDisplayElement), _sprite2(kNoDisplayElement), _sprite3(kNoDisplayElement) {
+		_extraMovie(kNoDisplayElement), _blankMovie(kNoDisplayElement), _playedSolvedMusicCue(false), _ripTimer(kNoDisplayElement),
+		_sprite1(kNoDisplayElement), _sprite2(kNoDisplayElement), _sprite3(kNoDisplayElement) {
 	setIsItemTaken(kJourneymanKey);
 	setIsItemTaken(kPegasusBiochip);
 	setIsItemTaken(kMapBiochip);
@@ -652,6 +661,12 @@ FullTSA::FullTSA(InputHandler *nextHandler, PegasusEngine *owner) : Neighborhood
 
 void FullTSA::init() {
 	Neighborhood::init();
+	_extraMovieCallBack.setNotification(&_neighborhoodNotification);
+	if (Common::File::exists("Images/TSA/Blank TSA.movie"))
+		_blankMovie.initFromMovieFile("Images/TSA/Blank TSA.movie");
+	_blankMovie.setVolume(_vm->getSoundFXLevel());
+	_blankMovie.setDisplayOrder(kNavMovieOrder + 1);
+	_blankMovie.startDisplaying();
 	_ripTimer.setDisplayOrder(kRipTimerOrder);
 	_ripTimer.startDisplaying();
 
@@ -677,6 +692,11 @@ void FullTSA::dieUncreatedInTSA() {
 void FullTSA::start() {
 	g_energyMonitor->stopEnergyDraining();
 
+	if (_vm->isDVD()) {
+		_entranceMusic.attachFader(&_entranceFader);
+		_entranceMusic.initFromAIFFFile("Sounds/TSA/TSA Entrance.32K.AIFF");
+		_entranceFader.setMasterVolume(_vm->getAmbienceLevel() / 2);
+	}
 	if (!GameState.getScoringEnterTSA()) {
 		_utilityFuse.primeFuse(GameState.getTSAFuseTimeLimit());
 		_utilityFuse.setFunctor(new Common::Functor0Mem<void, FullTSA>(this, &FullTSA::dieUncreatedInTSA));
@@ -836,24 +856,38 @@ void FullTSA::loadAmbientLoops() {
 	switch (GameState.getTSAState()) {
 	case kTSAPlayerDetectedRip:
 	case kTSAPlayerNeedsHistoricalLog:
-		if ((room >= kTSA16 && room <= kTSA0B) || (room >= kTSA21Cyan && room <= kTSA24Cyan) || (room >= kTSA21Red && room <= kTSA24Red))
-			loadLoopSound1("Sounds/TSA/TSA CLAXON.22K.AIFF", 0x100 / 4, 0, 0);
-		else if (room == kTSA25Cyan || room == kTSA25Red)
-			loadLoopSound1("Sounds/TSA/TSA CLAXON.22K.AIFF", 0x100 / 6, 0, 0);
-		else
-			loadLoopSound1("Sounds/TSA/TSA EchoClaxon.22K.AIFF", 0x100 / 4, 0, 0);
+		if (_vm->isDVD()) {
+			if ((room >= kTSA16 && room <= kTSA0B) || (room >= kTSA21Cyan && room <= kTSA24Cyan) || (room >= kTSA21Red && room <= kTSA24Red))
+				loadLoopSound1("Sounds/TSA/TSA CLAXON.44K.AIFF", 0x100 * 3 / 16, 0, 0);
+			else if (room == kTSA25Cyan || room == kTSA25Red)
+				loadLoopSound1("Sounds/TSA/TSA CLAXON.44K.AIFF", 0x100 / 8, 0, 0);
+			else
+				loadLoopSound1("Sounds/TSA/TSA EchoClaxon.22K.AIFF", 0x100 * 3 / 16, 0, 0);
+		} else {
+			if ((room >= kTSA16 && room <= kTSA0B) || (room >= kTSA21Cyan && room <= kTSA24Cyan) || (room >= kTSA21Red && room <= kTSA24Red))
+				loadLoopSound1("Sounds/TSA/TSA CLAXON.22K.AIFF", 0x100 / 4, 0, 0);
+			else if (room == kTSA25Cyan || room == kTSA25Red)
+				loadLoopSound1("Sounds/TSA/TSA CLAXON.22K.AIFF", 0x100 / 6, 0, 0);
+			else
+				loadLoopSound1("Sounds/TSA/TSA EchoClaxon.22K.AIFF", 0x100 / 4, 0, 0);
+		}
 		break;
 	default:
-		if (room >= kTSA00 && room <= kTSA02)
-			loadLoopSound1("Sounds/TSA/T01NAE.NEW.22K.AIFF");
-		else if (room >= kTSA03 && room <= kTSA15)
-			loadLoopSound1("Sounds/TSA/T01NAE.NEW.22K.AIFF");
-		else if (room >= kTSA16 && room <= kTSA0B)
-			loadLoopSound1("Sounds/TSA/T14SAEO1.22K.AIFF");
-		else if (room >= kTSA21Cyan && room <= kTSA25Red)
-			loadLoopSound1("Sounds/TSA/T15SAE01.22K.AIFF");
-		else if (room >= kTSA26 && room <= kTSA37)
-			loadLoopSound1("Sounds/TSA/T01NAE.NEW.22K.AIFF");
+		if (_vm->isDVD()) {
+			if ((room >= kTSA00 && room <= kTSA02) || (room >= kTSA03 && room <= kTSA15) || (room >= kTSA26 && room <= kTSA37))
+				loadLoopSound1("Sounds/TSA/T01NAE.NEW.32K.AIFF", 0x100 * 3 / 4, 0, 0);
+			else if (room >= kTSA16 && room <= kTSA0B)
+				loadLoopSound1("Sounds/TSA/T14SAEO1.32K.AIFF", 0x100 * 3 / 4, 0, 0);
+			else if (room >= kTSA21Cyan && room <= kTSA25Red)
+				loadLoopSound1("Sounds/TSA/T15SAE01.32K.AIFF", 0x100 * 3 / 4, 0, 0);
+		} else {
+			if ((room >= kTSA00 && room <= kTSA02) || (room >= kTSA03 && room <= kTSA15) || (room >= kTSA26 && room <= kTSA37))
+				loadLoopSound1("Sounds/TSA/T01NAE.NEW.22K.AIFF");
+			else if (room >= kTSA16 && room <= kTSA0B)
+				loadLoopSound1("Sounds/TSA/T14SAEO1.22K.AIFF");
+			else if (room >= kTSA21Cyan && room <= kTSA25Red)
+				loadLoopSound1("Sounds/TSA/T15SAE01.22K.AIFF");
+		}
 		break;
 	}
 }
@@ -1107,6 +1141,50 @@ void FullTSA::getExtraEntry(const uint32 id, ExtraTable::Entry &extraEntry) {
 		extraEntry.movieStart += kFullTSAFrameDuration * 3;
 }
 
+void FullTSA::showViewFrame(TimeValue viewTime) {
+	if ((int32)viewTime >= 0) {
+		_turnPush.hide();
+		_navMovie.stop();
+		_navMovie.setFlags(0);
+		if (_blankMovie.isMovieValid() &&
+			(GameState.getTSAState() == kRobotsAtCommandCenter ||
+			GameState.getTSAState() == kRobotsAtFrontDoor ||
+			GameState.getTSAState() == kRobotsAtReadyRoom) &&
+			(GameState.getCurrentRoom() == kTSA0A ||
+			GameState.getCurrentRoom() == kTSA06) &&
+			(GameState.getCurrentDirection() == kEast ||
+			GameState.getCurrentDirection() == kWest)) {
+			viewTime = 0;
+			if (GameState.getCurrentRoom() == kTSA06)
+				viewTime = 2 * _blankMovie.getScale();
+			if (GameState.getCurrentDirection() == kWest)
+				viewTime += _blankMovie.getScale();
+
+			_navMovie.hide();
+			_blankMovie.setSegment(0, _blankMovie.getDuration());
+			_blankMovie.setTime(viewTime);
+
+			Common::Rect pushBounds;
+			_turnPush.getBounds(pushBounds);
+
+			_blankMovie.moveElementTo(pushBounds.left, pushBounds.top);
+			_blankMovie.show();
+			_blankMovie.redrawMovieWorld();
+		} else {
+			_blankMovie.hide();
+			_navMovie.setSegment(0, _navMovie.getDuration());
+			_navMovie.setTime(viewTime);
+
+			Common::Rect pushBounds;
+			_turnPush.getBounds(pushBounds);
+
+			_navMovie.moveElementTo(pushBounds.left, pushBounds.top);
+			_navMovie.show();
+			_navMovie.redrawMovieWorld();
+		}
+	}
+}
+
 void FullTSA::pickedUpItem(Item *item) {
 	BiochipItem *biochip;
 
@@ -1191,6 +1269,117 @@ void FullTSA::startDoorOpenMovie(const TimeValue startTime, const TimeValue stop
 	Neighborhood::startDoorOpenMovie(startTime, stopTime);
 }
 
+void FullTSA::startTurnPush(const TurnDirection turnDirection, const TimeValue newView, const DirectionConstant nextDir) {
+	if (g_AIArea)
+		g_AIArea->lockAIOut();
+
+	_vm->_cursor->hide();
+
+	GameState.setNextDirection(nextDir);
+
+	_interruptionFilter = kFilterNoInput;
+	_turnPush.stopFader();
+
+	// Set up callback.
+	_turnPushCallBack.setCallBackFlag(kTurnCompletedFlag);
+	_turnPushCallBack.scheduleCallBack(kTriggerAtStop, 0, 0);
+
+	// Stop nav movie.
+	_navMovie.stop();
+	_navMovie.setFlags(0);
+
+	if (_blankMovie.isMovieValid() &&
+		(GameState.getTSAState() == kRobotsAtCommandCenter ||
+		GameState.getTSAState() == kRobotsAtFrontDoor ||
+		GameState.getTSAState() == kRobotsAtReadyRoom) &&
+		(GameState.getCurrentRoom() == kTSA0A || GameState.getCurrentRoom() == kTSA06) &&
+		(nextDir == kEast || nextDir == kWest)) {
+		TimeValue newRobotView = 0;
+		if (GameState.getCurrentRoom() == kTSA06)
+			newRobotView = 2 * _blankMovie.getScale();
+		if (nextDir == kWest)
+			newRobotView += _blankMovie.getScale();
+
+		_blankMovie.setSegment(0, _blankMovie.getDuration());
+
+		_pushIn.initFromMovieFrame(_blankMovie.getMovie(), newRobotView);
+		_turnPush.setInAndOutElements(&_pushIn, &_navMovie);		
+	} else {
+		// Set segment of nav movie to whole movie, so that subsequent initFromMovieFrame
+		// will work.
+		_navMovie.setSegment(0, _navMovie.getDuration());
+
+		_pushIn.initFromMovieFrame(_navMovie.getMovie(), newView);
+		if (_blankMovie.isMovieValid() &&
+			(GameState.getTSAState() == kRobotsAtCommandCenter ||
+			GameState.getTSAState() == kRobotsAtFrontDoor ||
+			GameState.getTSAState() == kRobotsAtReadyRoom) &&
+			(GameState.getCurrentRoom() == kTSA0A ||
+			GameState.getCurrentRoom() == kTSA06))
+			_turnPush.setInAndOutElements(&_pushIn, &_blankMovie);
+		else
+			_turnPush.setInAndOutElements(&_pushIn, &_navMovie);
+	}
+
+	_blankMovie.hide();
+	_navMovie.hide();
+
+	switch (turnDirection) {
+	case kTurnLeft:
+		_turnPush.setSlideDirection(kSlideRightMask);
+		break;
+	case kTurnRight:
+		_turnPush.setSlideDirection(kSlideLeftMask);
+		break;
+	case kTurnUp:
+		_turnPush.setSlideDirection(kSlideDownMask);
+		break;
+	case kTurnDown:
+		_turnPush.setSlideDirection(kSlideUpMask);
+		break;
+	}
+
+	_turnPush.show();
+
+	FaderMoveSpec moveSpec;
+	moveSpec.makeTwoKnotFaderSpec(60, 0, 0, 15, 1000);
+	_turnPush.startFader(moveSpec);
+
+	if (g_compass) {
+		_turnPush.pauseFader();
+
+		int32 startAngle = getStaticCompassAngle(GameState.getCurrentRoom(), GameState.getCurrentDirection());
+		int32 stopAngle = getStaticCompassAngle(GameState.getCurrentRoom(), nextDir);
+
+		if (turnDirection == kTurnLeft) {
+			if (startAngle < stopAngle)
+				startAngle += 360;
+		} else {
+			if (stopAngle < startAngle)
+				stopAngle += 360;
+		}
+
+		FaderMoveSpec turnSpec;
+		_turnPush.getCurrentFaderMove(turnSpec);
+
+		FaderMoveSpec compassMove;
+		compassMove.makeTwoKnotFaderSpec(turnSpec.getFaderScale(), turnSpec.getNthKnotTime(0), startAngle, turnSpec.getNthKnotTime(1), stopAngle);
+		g_compass->startFader(compassMove);
+	}
+
+	_turnPushCallBack.cancelCallBack();
+	_turnPush.continueFader();
+
+	do {
+		_vm->checkCallBacks();
+		_vm->refreshDisplay();
+		_vm->_system->delayMillis(10);
+	} while (_turnPush.isFading());
+
+	_turnPush.stopFader();
+	_neighborhoodNotification.setNotificationFlags(kTurnCompletedFlag, kTurnCompletedFlag);
+}
+
 InputBits FullTSA::getInputFilter() {
 	InputBits result = Neighborhood::getInputFilter();
 
@@ -1248,8 +1437,20 @@ void FullTSA::turnRight() {
 }
 
 void FullTSA::openDoor() {
+	FaderMoveSpec spec;
+
 	switch (GameState.getCurrentRoomAndView()) {
+	case MakeRoomView(kTSA14, kSouth):
+		if (_vm->isDVD()) {
+			spec.makeTwoKnotFaderSpec(10, 0, 255, 5, 0);
+			_entranceFader.startFader(spec);
+		}
+		break;
 	case MakeRoomView(kTSA15, kSouth):
+		if (_vm->isDVD()) {
+			spec.makeTwoKnotFaderSpec(10, 0, 255, 5, 0);
+			_entranceFader.startFader(spec);
+		}
 		if (GameState.getTSAState() == kTSAPlayerNeedsHistoricalLog || GameState.getTSAState() == kRobotsAtFrontDoor)
 			setCurrentAlternate(kAltTSARedAlert);
 		break;
@@ -1258,6 +1459,26 @@ void FullTSA::openDoor() {
 	Neighborhood::openDoor();
 }
 
+void FullTSA::doorOpened() {
+	if (_vm->isDVD()) {
+		switch (GameState.getCurrentRoomAndView()) {
+		case MakeRoomView(kTSA02, kNorth):
+			if (_lastExtra == kTSA02NorthDoorWithAgent3 && g_arthurChip) {
+				if (_vm->getRandomBit())
+					g_arthurChip->playArthurMovieForEvent("Images/AI/Globals/XGLOBB36", kArthurTSASawAgent3);
+				else
+					g_arthurChip->playArthurMovieForEvent("Images/AI/Globals/XGLOBB37", kArthurTSASawAgent3);
+			}
+			break;
+		case MakeRoomView(kTSA16, kSouth):
+		case MakeRoomView(kTSA21Cyan, kSouth):
+			_entranceMusic.stopSound();
+			break;
+		}
+	}
+	Neighborhood::doorOpened();
+}
+
 CanMoveForwardReason FullTSA::canMoveForward(ExitTable::Entry &entry) {
 	if (GameState.getCurrentRoomAndView() == MakeRoomView(kTSA25Red, kNorth))
 		return kCantMoveBlocked;
@@ -1265,6 +1486,27 @@ CanMoveForwardReason FullTSA::canMoveForward(ExitTable::Entry &entry) {
 	return Neighborhood::canMoveForward(entry);
 }
 
+void FullTSA::moveForward() {
+	ExitTable::Entry exitEntry;
+	CanMoveForwardReason moveReason = kCanMoveForward;
+	FaderMoveSpec spec;
+
+	if (_vm->isDVD()) {
+		moveReason = canMoveForward(exitEntry);
+		if (moveReason == kCanMoveForward &&
+			GameState.getCurrentRoomAndView() == MakeRoomView(kTSA02, kNorth) &&
+			!GameState.allTimeZonesFinished()) {
+			_entranceMusic.playSound();
+			spec.makeOneKnotFaderSpec(255);
+			_entranceFader.startFader(spec);
+		}
+	}
+	Neighborhood::moveForward();
+	if (moveReason == kCanMoveForward && GameState.getCurrentRoomAndView() == MakeRoomView(kTSA01, kSouth) &&
+		GameState.allTimeZonesFinished() && g_arthurChip)
+		g_arthurChip->playArthurMovieForEvent("Images/AI/Globals/XGLOBA51", kArthurTSALeaving);
+}
+
 CanOpenDoorReason FullTSA::canOpenDoor(DoorTable::Entry &entry) {
 	switch (GameState.getCurrentRoomAndView()) {
 	case MakeRoomView(kTSA02, kNorth):
@@ -1338,6 +1580,18 @@ void FullTSA::activateHotspots() {
 		if (!GameState.getTSAFrontDoorUnlockedOutside())
 			_vm->getAllHotspots().activateOneHotspot(kTSA02DoorSpotID);
 		break;
+	case MakeRoomView(kTSA0A, kEast):
+		if (GameState.getTSAState() == kRobotsAtCommandCenter ||
+			GameState.getTSAState() == kRobotsAtFrontDoor ||
+			GameState.getTSAState() == kRobotsAtReadyRoom)
+			_vm->getAllHotspots().deactivateOneHotspot(kTSA0AEastSpotID);
+		break;
+	case MakeRoomView(kTSA0A, kWest):
+		if (GameState.getTSAState() == kRobotsAtCommandCenter ||
+			GameState.getTSAState() == kRobotsAtFrontDoor ||
+			GameState.getTSAState() == kRobotsAtReadyRoom)
+			_vm->getAllHotspots().deactivateOneHotspot(kTSA0AWastSpotID);
+		break;
 	case MakeRoomView(kTSA0B, kEast):
 		if (GameState.getTSA0BZoomedIn())
 			switch (GameState.getTSAState()) {
@@ -1382,7 +1636,10 @@ void FullTSA::clickInHotspot(const Input &input, const Hotspot *clickedSpot) {
 		Neighborhood::clickInHotspot(input, clickedSpot);
 		break;
 	case kTSA03EastJimenezSpotID:
-		startExtraLongSequence(kTSA03JimenezZoomIn, kTSA03JimenezZoomOut, kExtraCompletedFlag, kFilterNoInput);
+		if (_vm->isDVD() && JMPPPInput::isEasterEggModifierInput(input))
+			startExtraSequence(kEasterEggJimenez, kExtraCompletedFlag, kFilterNoInput);
+		else
+			startExtraLongSequence(kTSA03JimenezZoomIn, kTSA03JimenezZoomOut, kExtraCompletedFlag, kFilterNoInput);
 		break;
 	case kTSA03WestCrenshawSpotID:
 		startExtraLongSequence(kTSA03CrenshawZoomIn, kTSA03CrenshawZoomOut, kExtraCompletedFlag, kFilterNoInput);
@@ -1391,10 +1648,16 @@ void FullTSA::clickInHotspot(const Input &input, const Hotspot *clickedSpot) {
 		startExtraLongSequence(kTSA04MatsumotoZoomIn, kTSA04MatsumotoZoomOut, kExtraCompletedFlag, kFilterNoInput);
 		break;
 	case kTSA04WestCastilleSpotID:
-		startExtraLongSequence(kTSA04CastilleZoomIn, kTSA04CastilleZoomOut, kExtraCompletedFlag, kFilterNoInput);
+		if (_vm->isDVD() && JMPPPInput::isEasterEggModifierInput(input))
+			startExtraSequence(kEasterEggCastillo, kExtraCompletedFlag, kFilterNoInput);
+		else
+			startExtraLongSequence(kTSA04CastilleZoomIn, kTSA04CastilleZoomOut, kExtraCompletedFlag, kFilterNoInput);
 		break;
 	case kTSA05EastSinclairSpotID:
-		startExtraLongSequence(kTSA05SinclairZoomIn, kTSA05SinclairZoomOut, kExtraCompletedFlag, kFilterNoInput);
+		if (_vm->isDVD() && JMPPPInput::isEasterEggModifierInput(input))
+			startExtraSequence(kEasterEggSinclair, kExtraCompletedFlag, kFilterNoInput);
+		else
+			startExtraLongSequence(kTSA05SinclairZoomIn, kTSA05SinclairZoomOut, kExtraCompletedFlag, kFilterNoInput);
 		break;
 	case kTSA05WestWhiteSpotID:
 		startExtraLongSequence(kTSA05WhiteZoomIn, kTSA05WhiteZoomOut, kExtraCompletedFlag, kFilterNoInput);
@@ -1551,6 +1814,12 @@ void FullTSA::clickInHotspot(const Input &input, const Hotspot *clickedSpot) {
 	// Pegasus
 	case kTSA37NorthJumpToPrehistoricSpotID:
 		startExtraSequence(kTSA37PegasusDepart, kExtraCompletedFlag, kFilterNoInput);
+		if (g_arthurChip) {
+			if (_vm->getRandomBit())
+				g_arthurChip->playArthurMovieForEvent("Images/AI/Globals/XGLOBA30", kArthurTSAUsedPegasus);
+			else
+				g_arthurChip->playArthurMovieForEvent("Images/AI/Globals/XGLOBA35", kArthurTSAUsedPegasus);
+		}
 		break;
 	case kTSA37NorthExitSpotID:
 		_sprite2.setCurrentFrameIndex(1);
@@ -1886,7 +2155,7 @@ void FullTSA::playRightComparison() {
 // TSA state is kTSABossSawHistoricalLog.
 void FullTSA::startRobotGame() {
 	requestExtraSequence(kTSA0BNorthCantChangeHistory, 0, kFilterNoInput);
-	requestExtraSequence(kTSA0BAIInterruption, 0, kFilterNoInput);
+	requestExtraSequence(kTSA0BAIInterruption, kExtraCompletedFlag, kFilterNoInput);
 	requestExtraSequence(kTSA0BShowGuardRobots, 0, kFilterNoInput);
 	requestExtraSequence(kTSA0BRobotsToCommandCenter, kExtraCompletedFlag, kFilterNoInput);
 }
@@ -1900,7 +2169,7 @@ void FullTSA::startUpRobotMonitor() {
 	_sprite1.addPICTResourceFrame(kRedirectionRRRolloverPICTID, true,
 			kRedirectionRRRolloverLeft - kRedirectionSprite1Left,
 			kRedirectionRRRolloverTop - kRedirectionSprite1Top);
-	_sprite1.addPICTResourceFrame(kRedirectionFDRolloverPICTID, false,
+	_sprite1.addPICTResourceFrame(kRedirectionFDRolloverPICTID, true,
 			kRedirectionFDRolloverLeft - kRedirectionSprite1Left,
 			kRedirectionFDRolloverTop - kRedirectionSprite1Top);
 	_sprite1.addPICTResourceFrame(kRedirectionCCDoorPICTID, true,
@@ -1909,7 +2178,7 @@ void FullTSA::startUpRobotMonitor() {
 	_sprite1.addPICTResourceFrame(kRedirectionRRDoorPICTID, true,
 			kRedirectionRRDoorLeft - kRedirectionSprite1Left,
 			kRedirectionRRDoorTop - kRedirectionSprite1Top);
-	_sprite1.addPICTResourceFrame(kRedirectionFDDoorPICTID, false,
+	_sprite1.addPICTResourceFrame(kRedirectionFDDoorPICTID, true,
 			kRedirectionFDDoorLeft - kRedirectionSprite1Left,
 			kRedirectionFDDoorTop - kRedirectionSprite1Top);
 	_sprite1.addPICTResourceFrame(kRedirectionClosePICTID, false,
@@ -1994,11 +2263,14 @@ void FullTSA::arriveAt(const RoomID room, const DirectionConstant direction) {
 			loopExtraSequence(kTSATransporterArrowLoop, 0);
 		}
 		break;
+	case MakeRoomView(kTSA01, kNorth):
+		if (g_arthurChip)
+			g_arthurChip->playArthurMovieForEvent("Images/AI/Globals/XGLOBA22", kArthurTSAEnteredCave);
+		break;
 	case MakeRoomView(kTSA03, kNorth):
 	case MakeRoomView(kTSA05, kNorth):
 	case MakeRoomView(kTSA0A, kNorth):
 	case MakeRoomView(kTSA06, kNorth):
-	case MakeRoomView(kTSA07, kNorth):
 		if (_utilityFuse.isFuseLit())
 			_utilityFuse.stopFuse();
 		GameState.setScoringEnterTSA(true);
@@ -2009,6 +2281,13 @@ void FullTSA::arriveAt(const RoomID room, const DirectionConstant direction) {
 		if (!GameState.getTSASeenRobotGreeting())
 			startExtraSequence(kTSA04NorthRobotGreeting, kExtraCompletedFlag, kFilterNoInput);
 		break;
+	case MakeRoomView(kTSA07, kNorth):
+		if (_utilityFuse.isFuseLit())
+			_utilityFuse.stopFuse();
+		GameState.setScoringEnterTSA(true);
+		if (g_arthurChip)
+			g_arthurChip->playArthurMovieForEvent("Images/AI/Globals/XGLOBA23", kArthurTSAReachedJunction);
+		break;
 	case MakeRoomView(kTSA03, kSouth):
 		GameState.setTSAFrontDoorUnlockedInside(GameState.getTSAState() == kRobotsAtFrontDoor || GameState.allTimeZonesFinished());
 		break;
@@ -2093,8 +2372,15 @@ void FullTSA::arriveAt(const RoomID room, const DirectionConstant direction) {
 		arriveAtTSA25Red();
 		break;
 	case MakeRoomView(kTSA34, kSouth):
-		if (GameState.getLastRoom() == kTSA37)
+		if (GameState.getLastRoom() == kTSA37) {
 			closeDoorOffScreen(kTSA37, kNorth);
+			if (_vm->isDVD() && GameState.allTimeZonesFinished() && !_playedSolvedMusicCue) {
+				_solvedMusicCue.initFromAIFFFile("Sounds/TSA/TSA NORM.32K.AIFF");
+				_solvedMusicCue.setVolume(_vm->getAmbienceLevel());
+				_solvedMusicCue.playSound();
+				_playedSolvedMusicCue = true;
+			}
+		}
 		break;
 	case MakeRoomView(kTSA37, kNorth):
 		arriveAtTSA37();
@@ -2132,7 +2418,8 @@ void FullTSA::checkRobotLocations(const RoomID room, const DirectionConstant dir
 			switch (GameState.getTSAState()) {
 			case kRobotsAtCommandCenter:
 				if (!_privateFlags.getFlag(kTSAPrivateSeenRobotWarningFlag)) {
-					g_AIArea->playAIMovie(kRightAreaSignature, "Images/AI/TSA/XT11WB", false, kWarningInterruption);
+					if (g_AIArea->isChattyAI())
+						g_AIArea->playAIMovie(kRightAreaSignature, "Images/AI/TSA/XT11WB", false, kWarningInterruption);
 					_privateFlags.setFlag(kTSAPrivateSeenRobotWarningFlag, true);
 				}
 				break;
@@ -2286,7 +2573,8 @@ void FullTSA::turnTo(const DirectionConstant newDirection) {
 		switch (GameState.getTSAState()) {
 		case kRobotsAtCommandCenter:
 			if (!_privateFlags.getFlag(kTSAPrivateSeenRobotWarningFlag)) {
-				g_AIArea->playAIMovie(kRightAreaSignature, "Images/AI/TSA/XT11WB", false, kWarningInterruption);
+				if (g_AIArea->isChattyAI())
+					g_AIArea->playAIMovie(kRightAreaSignature, "Images/AI/TSA/XT11WB", false, kWarningInterruption);
 				_privateFlags.setFlag(kTSAPrivateSeenRobotWarningFlag, true);
 			}
 			break;
@@ -2355,6 +2643,65 @@ void FullTSA::closeDoorOffScreen(const RoomID room, const DirectionConstant) {
 	}
 }
 
+void FullTSA::startExtraSequence(const ExtraID extraID, const NotificationFlags flags, const InputBits interruptionFilter) {
+	static const TimeValue times[3][2] = {
+		{ 0, 11720 },
+		{ 11720, 19840 },
+		{ 19840, 29960 }
+	};
+	TimeValue segmentStart = 0, segmentStop = 0;
+	bool loopSequence = false;
+	Common::Rect pushBounds;
+	NotificationFlags extraFlags;
+
+	switch (extraID) {
+	case kEasterEggJimenez:
+	case kEasterEggCastillo:
+	case kEasterEggSinclair:
+		_turnPush.getBounds(pushBounds);
+		_extraMovie.initFromMovieFile("Images/TSA/Wacky TSA.movie");
+		segmentStart = times[extraID - 1000][0];
+		segmentStop = times[extraID - 1000][1];
+		loopSequence = false;
+		
+		_lastExtra = extraID;
+		_turnPush.hide();
+		
+		if (!loopSequence && g_AIArea)
+			g_AIArea->lockAIOut();
+		
+		extraFlags = flags;
+		_interruptionFilter = interruptionFilter;
+		// Stop the nav movie before doing anything else
+		_navMovie.stop();
+		_navMovie.stopDisplaying();
+		
+		_extraMovie.setVolume(_vm->getSoundFXLevel());
+		_extraMovie.moveElementTo(pushBounds.left, pushBounds.top);
+		_extraMovie.setDisplayOrder(kNavMovieOrder + 1);
+		_extraMovie.startDisplaying();
+		_extraMovie.show();
+		_extraMovie.setFlags(0);
+		_extraMovie.setSegment(segmentStart, segmentStop);
+		_extraMovie.setTime(segmentStart);
+		if (loopSequence)
+			_extraMovie.setFlags(kLoopTimeBase);
+		else
+			extraFlags |= kNeighborhoodMovieCompletedFlag;
+		_extraMovieCallBack.cancelCallBack();
+		_extraMovieCallBack.initCallBack(&_extraMovie, kCallBackAtExtremes);
+		if (extraFlags != 0) {
+			_extraMovieCallBack.setCallBackFlag(extraFlags);
+			_extraMovieCallBack.scheduleCallBack(kTriggerAtStop, 0, 0);
+		}
+		_extraMovie.start();
+		break;
+	default:
+		Neighborhood::startExtraSequence(extraID, flags, interruptionFilter);
+		break;
+	}
+}
+
 void FullTSA::receiveNotification(Notification *notification, const NotificationFlags flags) {
 	ExtraID lastExtra = _lastExtra;
 
@@ -2372,12 +2719,15 @@ void FullTSA::receiveNotification(Notification *notification, const Notification
 	Neighborhood::receiveNotification(notification, flags);
 
 	InventoryItem *item;
+	bool doArthurSawBustMovie, doArthurRedirectedRobotsMovie;
 
 	if ((flags & kExtraCompletedFlag) != 0) {
 		// Only allow input if we're not in the middle of series of queue requests.
 		if (actionQueueEmpty())
 			_interruptionFilter = kFilterAllInput;
 
+		doArthurSawBustMovie = false;
+		doArthurRedirectedRobotsMovie = false;
 		switch (lastExtra) {
 		case kTSAGTCardSwipe:
 			item = (InventoryItem *)_vm->getAllItems().findItemByID(kKeyCard);
@@ -2408,21 +2758,43 @@ void FullTSA::receiveNotification(Notification *notification, const Notification
 			break;
 		case kTSA03JimenezZoomIn:
 			GameState.setScoringSawBust1(true);
+			doArthurSawBustMovie = true;
 			break;
 		case kTSA03CrenshawZoomIn:
 			GameState.setScoringSawBust2(true);
+			doArthurSawBustMovie = true;
 			break;
 		case kTSA04MatsumotoZoomIn:
 			GameState.setScoringSawBust3(true);
+			doArthurSawBustMovie = true;
 			break;
 		case kTSA04CastilleZoomIn:
 			GameState.setScoringSawBust4(true);
+			doArthurSawBustMovie = true;
 			break;
 		case kTSA05SinclairZoomIn:
 			GameState.setScoringSawBust5(true);
+			doArthurSawBustMovie = true;
 			break;
 		case kTSA05WhiteZoomIn:
 			GameState.setScoringSawBust6(true);
+			doArthurSawBustMovie = true;
+			break;
+		case kEasterEggJimenez:
+		case kEasterEggCastillo:
+		case kEasterEggSinclair:
+			_extraMovie.stopDisplaying();
+			_extraMovie.releaseMovie();
+			_navMovie.startDisplaying();
+			doArthurSawBustMovie = true;
+			break;
+		case kTSA0AEastRobot:
+			if (g_arthurChip)
+				g_arthurChip->playArthurMovieForEvent("Images/AI/Globals/XGLOBA48", kArthurTSAClickedRobot1);
+			break;
+		case kTSA0AWestRobot:
+			if (g_arthurChip)
+				g_arthurChip->playArthurMovieForEvent("Images/AI/Globals/XGLOBA53", kArthurTSAClickedRobot2);
 			break;
 
 		// Command center
@@ -2526,15 +2898,20 @@ void FullTSA::receiveNotification(Notification *notification, const Notification
 		case kTSA0BShowGuardRobots:
 			startUpRobotMonitor();
 			// Fall through
+		case kTSA0BRobotsFromCommandCenterToFrontDoor:
+		case kTSA0BRobotsFromReadyRoomToFrontDoor:
+			doArthurRedirectedRobotsMovie = true;
 		case kTSA0BRobotsFromCommandCenterToReadyRoom:
 		case kTSA0BRobotsFromReadyRoomToCommandCenter:
-		case kTSA0BRobotsFromCommandCenterToFrontDoor:
 		case kTSA0BRobotsFromFrontDoorToCommandCenter:
 		case kTSA0BRobotsFromFrontDoorToReadyRoom:
-		case kTSA0BRobotsFromReadyRoomToFrontDoor:
 			_sprite2.setCurrentFrameIndex(kRedirectionSecuredSprite);
 			_sprite2.show();
 			break;
+		case kTSA0BAIInterruption:
+			if (g_arthurChip)
+				g_arthurChip->playArthurMovieForEvent("Images/AI/Globals/XGLOBA52", kArthurTSAConfinedByBaldwin);
+			break;
 
 		// TBP monitor.
 		case kTSA0BWestZoomIn:
@@ -2548,6 +2925,8 @@ void FullTSA::receiveNotification(Notification *notification, const Notification
 			}
 
 			initializeTBPMonitor(kMonitorNeutral, 0);
+			if (GameState.getTSAState() == kTSAPlayerForcedReview && g_arthurChip)
+				g_arthurChip->playArthurMovieForEvent("Images/AI/Globals/XGLOBA55", kArthurTSAOpenTBPMonitor);
 			break;
 		case kTSA0BWestZoomOut:
 			GameState.setTSA0BZoomedIn(false);
@@ -2574,18 +2953,26 @@ void FullTSA::receiveNotification(Notification *notification, const Notification
 		case kTSA22RedEastZoomInSequence:
 			_privateFlags.setFlag(kTSAPrivateKeyVaultOpenFlag, true);
 			setCurrentActivation(kActivationKeyVaultOpen);
+			if (g_arthurChip)
+				g_arthurChip->playArthurMovieForEvent("Images/AI/Globals/XGLOBA50", kArthurTSASawJourneymanKey);
 			break;
 		case kTSA23RedWestVaultZoomInSequence:
 			_privateFlags.setFlag(kTSAPrivateChipVaultOpenFlag, true);
 			setCurrentActivation(kActivationChipVaultOpen);
+			if (g_arthurChip)
+				g_arthurChip->playArthurMovieForEvent("Images/AI/Globals/XGLOBA54", kArthurTSASawBiochips);
 			break;
 		case kTSA25NorthPutOnSuit:
 			GameState.setTSABiosuitOn(true);
 			GameState.setScoringGotBiosuit(true);
 			// Fall through...
 		case kTSA25NorthAlreadyHaveSuit:
-			requestExtraSequence(kTSA25NorthDescending1, 0, kFilterNoInput);
+			requestExtraSequence(kTSA25NorthDescending1, kExtraCompletedFlag, kFilterNoInput);
+			break;
+		case kTSA25NorthDescending1:
 			requestExtraSequence(kTSA25NorthDescending2, kExtraCompletedFlag, kFilterNoInput);
+			if (GameState.getTSAState() != kTSAPlayerNeedsHistoricalLog && g_arthurChip)
+				g_arthurChip->playArthurMovieForEvent("Images/AI/Globals/XGLOBA04", kArthurTSAUsedTurbolift);
 			break;
 		case kTSA25NorthDescending2:
 			arriveAt(kTSA26, kNorth);
@@ -2745,13 +3132,31 @@ void FullTSA::receiveNotification(Notification *notification, const Notification
 		case kTSA37CongratulationsToExit:
 			GameState.setTSAState(kPlayerFinishedWithTSA);
 			initializePegasusButtons(true);
+			if (g_arthurChip) {
+				if (_vm->getRandomBit())
+					g_arthurChip->playArthurMovieForEvent("Images/AI/Globals/XGLOBA49", kArthurTSASawBaldwinSayGo);
+				else
+					g_arthurChip->playArthurMovieForEvent("Images/AI/Globals/XGLOBB22", kArthurTSASawBaldwinSayGo);
+			}
 			break;
 		}
+		if (g_arthurChip) {
+			if (doArthurSawBustMovie)
+				g_arthurChip->playArthurMovieForEvent("Images/AI/Globals/XGLOBA21", kArthurTSASawBust);
+			else if (doArthurRedirectedRobotsMovie && GameState.getTSAState() == kRobotsAtFrontDoor)
+				g_arthurChip->playArthurMovieForEvent("Images/AI/Globals/XGLOBA02", kArthurTSARedirectedRobots);
+		}
 	}
 
 	g_AIArea->checkMiddleArea();
 }
 
+void FullTSA::setAmbienceLevel(const uint16 level) {
+	Neighborhood::setAmbienceLevel(level);
+	if (_entranceMusic.isSoundLoaded())
+		_entranceFader.setMasterVolume(level);
+}
+
 void FullTSA::arriveFromPrehistoric() {
 	if (_vm->playerHasItemID(kHistoricalLog)) {
 		GameState.setScoringFinishedPrehistoric();
